require "import"
import "android.webkit.CookieManager"
import "net.fusionapp.core.ui.fragment.WebInterface"
import "android.os.Bundle"
import "android.os.*"
import "android.widget.*"
import "android.view.*"
fragment=activity.uiManager.currentFragment
web=fragment.webView
local intent=activity.getIntent()
local uiManager=activity.getUiManager()
--获取当前页面的WebView
local webView=uiManager.getCurrentFragment().getWebView()
webView.loadUrl(intent.getStringExtra("url"))
--print(intent.getStringExtra("url"))
function copy(text)
  activity.getSystemService("clipboard").setText(text)
end

function onDrawerListItemClick(data, recyclerView, listIndex, itemIndex)
  local listData = data.get(listIndex);
  local itemData = listData.get(itemIndex);
  local itemTitle = itemData.getTitle();
  print(itemTitle)
end

function onSearchEvent(keyword)
  print("Search keyword:"..keyword)
end

--个人中心
function onFloatingActionButtonClick(v)
  web.reload()
end
--copy(CookieManager.getInstance().getCookie("https://ysqbbs.com/"))
function dp2px(dpValue)
  local scale = activity.getResources().getDisplayMetrics().scaledDensity
  return dpValue * scale + 0.5
end

import "com.google.android.material.card.MaterialCardView"
import "com.google.android.material.bottomsheet.BottomSheetDialog"
import "android.content.res.ColorStateList"
import "android.graphics.drawable.GradientDrawable"

local BottomSheetDialogdrawable = GradientDrawable()
BottomSheetDialogdrawable.setShape(GradientDrawable.RECTANGLE)
BottomSheetDialogdrawable.setColor(0xffffffff)
BottomSheetDialogdrawable.setCornerRadii({dp2px(8),dp2px(8),dp2px(8),dp2px(8),0,0,0,0});


if activity.getPackageName()=="net.fusionapp" then
  R=luajava.bindClass "net.fusionapp.R"
 else
  R=luajava.bindClass "net.fusionapp.core.R"
end

function Ripple(view,color)
  import "android.content.res.ColorStateList"
  local attrsArray = {android.R.attr.selectableItemBackgroundBorderless}
  local typedArray =activity.obtainStyledAttributes(attrsArray)
  local ripple=typedArray.getResourceId(0,0)
  local Pretend=activity.Resources.getDrawable(ripple)
  Pretend.setColor(ColorStateList(int[0].class{int{}},int{color}))
  return Pretend.setColor(ColorStateList(int[0].class{int{}},int{color}))
end
local uiManager=this.uiManager
local colors=uiManager.getColors()
colorPrimary=colors.colorPrimary--主色
colorTextPrimary=colors.textColorPrimary--主文本色

function Dialog(title,content,mButton1,mButton2,mButton3,mButton1_,mButton2_,mButton3_)
  import "com.google.android.material.bottomsheet.BottomSheetDialog"
  mBottomSheetDialog=BottomSheetDialog(activity);
  mBottomSheetDialog.setContentView(loadlayout({
    LinearLayout;
    layout_height="match_parent";
    BackgroundDrawable=BottomSheetDialogDrawable;
    layout_width="match_parent";
    orientation="vertical";
    {
      LinearLayout;
      layout_marginTop="5dp";
      layout_width="-1";
      gravity="center";
      -- BackgroundColor="#FFFFFFFF";
      {
        MaterialCardView;
        layout_height="8dp";
        CardElevation="0dp";
        radius="4dp";
        layout_margin="5dp";
        layout_width="75dp";
        CardBackgroundColor="#FFF4F5F7";
      };
    };
    {
      TextView;
      layout_width="-1";
      layout_height="-2";
      textSize="20sp";
      layout_marginTop="9dp";
      layout_marginLeft="24dp";
      layout_marginRight="24dp";
      layout_marginBottom="0dp";
      Text=title;
      textStyle="bold";
      textColor=colorTextPrimary;
    };
    {
      ScrollView;
      layout_width="match_parent";
      layout_height="-2";
      layout_weight=100;
      {
        TextView;
        id="_view";
        textIsSelectable=true;
        text=content;
        paddingTop="8dp";
        paddingBottom="8dp";
        paddingRight="24dp";
        paddingLeft="24dp";
        layout_width="match_parent";
      };
    };
    {
      LinearLayout;
      layout_height="-2";
      layout_weight=1;
      layout_width="match_parent";
      orientation="vertical";
      {
        MaterialCardView;
        layout_weight=1;
        layout_height="50dp";
        CardElevation="3dp";
        radius="25dp";
        layout_marginTop="10dp";
        layout_marginRight="20dp";
        layout_marginLeft="20dp";
        layout_width="-1";
        CardBackgroundColor=0xff0984fd;
        onClick=mButton3_;
        {
          LinearLayout;
          layout_height="match_parent";
          gravity="center";
          layout_width="match_parent";
          focusable="true";
          {
            TextView;
            textStyle="bold";
            Text=mButton3;
            textColor=0xFFFFFFFF;
            textSize="15sp";
          };
        };
      };
      {
        LinearLayout;
        layout_height="-2";
        layout_width="match_parent";
        orientation="horizontal";
        {
          MaterialCardView;
          layout_weight=1;
          layout_height="50dp";
          CardElevation="3dp";
          radius="25dp";
          layout_marginTop="20dp";
          layout_marginRight="10dp";
          layout_marginLeft="20dp";
          layout_marginBottom="20dp";
          layout_width="-1";
          CardBackgroundColor=colorPrimary;
          onClick=mButton1_;
          {
            LinearLayout;
            layout_height="match_parent";
            gravity="center";
            layout_width="match_parent";
            focusable="true";
            {
              TextView;
              textStyle="bold";
              Text=mButton1;
              textColor=colorTextPrimary;
              textSize="15sp";
            };
          };
        };
        {
          MaterialCardView;
          layout_weight=1;
          layout_height="50dp";
          CardElevation="3dp";
          radius="25dp";
          layout_marginTop="20dp";
          layout_marginRight="20dp";
          layout_marginLeft="10dp";
          layout_marginBottom="20dp";
          layout_width="-1";
          CardBackgroundColor=colorPrimary;
          onClick=mButton2_;
          {
            LinearLayout;
            layout_height="match_parent";
            gravity="center";
            layout_width="match_parent";
            focusable="true";
            {
              TextView;
              textStyle="bold";
              Text=mButton2;
              textColor=colorTextPrimary;
              textSize="15sp";
            };
          };
        };
      };
    };
  })).getWindow().setDimAmount(0.5);
  if Build.VERSION.SDK_INT >= 21 then
    mBottomSheetDialog.getWindow().addFlags(WindowManager.LayoutParams.FLAG_DRAWS_SYSTEM_BAR_BACKGROUNDS);
  end
  mBottomSheetDialog.getWindow().findViewById(R.id.design_bottom_sheet).setBackgroundResource(android.R.color.transparent);
  mBottomSheetDialog.show();
  if content==nil then
    _view.setVisibility(View.GONE)
  end
end

function Login()
  activity.startFusionActivity("login")
end
function onMenuItemClick(title)
  switch title
   case "退出"
    activity.finish()
   case "复制链接"
    --先导入包
    local uiManager=activity.getUiManager()
    --获取当前页面的WebView
    local webView=uiManager.getCurrentFragment().getWebView()
    import "android.content.*"
    activity.getSystemService(Context.CLIPBOARD_SERVICE).setText(webView.getUrl())
   case "浏览器打开"
    local uiManager=activity.getUiManager()
    --获取当前页面的WebView
    local webView=uiManager.getCurrentFragment().getWebView()
    import "android.content.Intent"
    import "android.net.Uri"
    local viewIntent = Intent("android.intent.action.VIEW",Uri.parse(webView.getUrl()))
    activity.startActivity(viewIntent)
   case "原网页菜单"
    local uimanager=activity.uiManager
    local view=uimanager.currentFragment.getWebView()
    view.evaluateJavascript([[document.getElementById("comiis_menu_tr").click();]],function end)
   case "刷新"
    web.reload()
   case "分享网页"
    import "androidx.core.app.ShareCompat"
    ShareCompat.IntentBuilder
    .from(activity)
    .setText(activity.uiManager.currentFragment.getWebView().getTitle().."\n"..activity.uiManager.currentFragment.getWebView().getUrl())
    .setType("text/plain")
    .startChooser();
   case "网页查找"
    uiManager=activity.getUiManager()
    --获取浏览器控件
    webView=uiManager.getCurrentFragment().getWebView()
    import"com.google.android.material.dialog.MaterialAlertDialogBuilder"
    import "android.content.res.ColorStateList"
    local AlertDialog = luajava.bindClass "androidx.appcompat.app.AlertDialog"
    local TextInputLayout = luajava.bindClass "com.google.android.material.textfield.TextInputLayout"
    local TextInputEditText = luajava.bindClass "com.google.android.material.textfield.TextInputEditText"
    local WindowManager = luajava.bindClass "android.view.WindowManager"
    local view_table=
    {LinearLayout,
      layout_width="match",
      layout_height="match",
      orientation=1,
      {TextInputLayout,
        id="input_layout",
        layout_height="wrap",
        layout_marginLeft="20dp",
        layout_marginRight="20dp",
        layout_width="match",
        hint="内容",--设置输入框提示文本
        {TextInputEditText,
          id="edit_text",
          text=this.getSharedData("lookup"),
          layout_height="wrap",
          layout_width="match",
        },
      },

    }
    local function onSearchEvent(input)
      if input then
        webView.findAllAsync(input)
       else
        webView.findNext(true)
      end
      this.setSharedData("lookup",input)
      return true
    end

    local dialog=MaterialAlertDialogBuilder(activity)
    .setTitle("网页查找")
    .setView(loadlayout(view_table))
    .setPositiveButton("下一个",nil)
    .setNegativeButton("取消",{
      onClick=function()
        webView.clearMatches()
      end
    })
    .show()
    dialog.getButton(AlertDialog.BUTTON1).onClick=function()
      onSearchEvent(edit_text.text)
    end
    local lp =dialog.getWindow().getAttributes()
    lp.alpha = 0.6
    dialog.getWindow().setAttributes(lp)
    --local ColorDrawable = luajava.bindClass "android.graphics.drawable.ColorDrawable"
    --dialog.getWindow().setBackgroundDrawable(ColorDrawable());
    local lp = dialog.getWindow().getAttributes();
    lp.dimAmount=0.0
    dialog.getWindow().setAttributes(lp);
    dialog.getWindow().addFlags(WindowManager.LayoutParams.FLAG_DIM_BEHIND);
    import "android.graphics.Color"
    local colorAccent=Color.parseColor(activity.getUiManager().getColors().colorAccent)
    import "android.content.res.ColorStateList"
    local colorRipple=ColorStateList.valueOf(0x44444444)
    dialog.getButton(dialog.BUTTON_POSITIVE).setTextColor(colorAccent).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEUTRAL).setTextColor(colorAccent).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEGATIVE).setTextColor(colorAccent).setRippleColor(colorRipple)
   case "历史消息"
    local packagej=webView.getUrl():match'uid=(.+)&' or webView.getUrl():match'touid=(.+)'
    if packagej then
      webView.loadUrl("https://ysqbbs.com/home.php?mod=space&do=pm&subop=view&touid="..packagej.."&viewall=1")
     else
      print("失败")
    end
   case "电脑版"
    local bundle=Bundle()
    bundle.putString("url",web.getUrl())
    --bundle.putInt("key",0)
    activity.startFusionActivity("Computerversion",bundle)

  end
end

local uimanager=activity.uiManager
local fragment=uimanager.currentFragment.getWebView()
import "android.webkit.WebViewClient"
fragment.setWebViewClient(luajava.override(WebViewClient,{
  onPageFinished=function(_,view,url)
    --页面加载结束事件
    view.evaluateJavascript([[document.getElementById("comiis_foot_memu").setAttribute("style","display:block");]],function end)
    if this.getSharedData("显示FPS")=="true" then
      view.evaluateJavascript("Display_fps();",function end)
    end
    if this.getSharedData("URL超连接")=="true" then
      view.evaluateJavascript("url_clickable();",function end)
    end
    
    local packageName2_0=url:match'ysqbbs%.com/home.php%?mod=space&do=pm&subop=view&touid=.+&'
    local packageName2_1=url:match'ysqbbs%.com/home%.php%?mod=space&do=thread&view=me&type=.+'
    local packageName20=url:match'ysqbbs%.com/home.php%?mod=space&do=pm&subop=view&touid=.+'
    if packageName20 and !packageName2_0 then

      view.evaluateJavascript([[document.getElementsByClassName("flex")[0].innerHTML
]],function(a)
        local uiManager=this.uiManager
        local toolbar=uiManager.toolbar
        --设置toolbar标题
        toolbar.titleText=("("..a:match('">%((.+)%)')..") - "..a:match('                    (.-).u003C')) or "获取失败"
        --copy(html转义(a))--"\n稻草人Q比\u003Cfontclass=\"f14\">(离线)\u003C/font>\t\t\t\n"
      end)
     elseif packageName2_0 or packageName2_1 then
      view.evaluateJavascript('document.getElementById("comiis_foot_memu").setAttribute("style","display:none");',function end)
    end
  end,
  shouldOverrideUrlLoading=function(_,view,webResourceRequest)
    local url=tostring(webResourceRequest.getUrl())
    local packageName3=url:match'ysqbbs%.com/forum%-.+%-.+%.html'
    local packageName5=url:match'ysqbbs%.com'
    local packageName4=url:match'ysqbbs%.com/thread%-.+%-.+%-.+%.html'
    --local packageName6=url:match'ysqbbs%.com/home.php%?mod=space&uid=.+&do=profile'
    local packageName=url:match'ysqbbs%.com/member%.php%?mod=logging&action=login'
    local packageName17=url:match'ysqbbs%.com/forum%.php%?mod=forumdisplay&action=list&fid=.+'
    local packageName19=url:match'ysqbbs%.com/forum%-.+%-.+%.html'
    local packageName18=url:match'ysqbbs%.com/group%.php%?mod=index.+'
    local packageName25=url:match'ysqbbs%.com/forum%.php%?mod=post&action=newthread&fid=.+'
    local packageName26=url:match'ysqbbs%.com/forum%.php%?mobile=no'
    if packageName then
      Login()
      return true
     elseif packageName4 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Detailsofthepost",bundle)
      return true
     elseif packageName3 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Plate",bundle)
      return true
     elseif !packageName5 then
      Dialog("即将离开本站","您即将离开源社区，请注意您的帐号和财产安全。\n\n"..url,"复制链接","浏览器打开","继续访问",
      function()
        mBottomSheetDialog.dismiss()
        activity.getSystemService("clipboard").setText(url)
      end,
      function()
        mBottomSheetDialog.dismiss()
        import "android.content.Intent"
        import "android.net.Uri"
        local viewIntent = Intent("android.intent.action.VIEW",Uri.parse(url))
        activity.startActivity(viewIntent)
      end,
      function()
        mBottomSheetDialog.dismiss()
        local bundle=Bundle()
        bundle.putString("url",url)
        --bundle.putInt("key",0)
        activity.startFusionActivity("Browsepage",bundle)
      end)
      return true
     elseif packageName17 or packageName19 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Plate",bundle)
      return true
     elseif packageName18 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Circle",bundle)
      return true
     elseif packageName25 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Detailsofthepost",bundle)
      return true
     elseif packageName26 then
      activity.startFusionActivity("Computerversion")
      return true
     else
      return false
    end
  end,
}))
local WebChromeClient = luajava.bindClass "android.webkit.WebChromeClient"
fragment.setWebChromeClient(luajava.override(WebChromeClient,{
  onProgressChanged=function(a,view,progress)
    view.parent.getChildAt(2).progress=progress
  end,
  onReceivedTitle=function(a,view,title)
    local uiManager=this.uiManager
    local toolbar=uiManager.toolbar
    --设置toolbar标题
    toolbar.titleText=title
  end,
}))