--
-- @author 寒歌
-- @description Main是应用的主模块，其中注册了应用运行中UI事件的回调、Activity生命周期的回调等
-- 你也可以在此编写启动事件代码，或控制应用运行逻辑、自定义应用UI等等。
-- @other 本模版已为你编写好基础事件，建议在阅读注释并理解相关参数意义后再进行扩展编写
--

-- ****默认导入包****
require "import"
import "android.os.*"
import "android.widget.*"
import "android.view.*"
-- ****不需要请删除****

-- @param data 侧滑栏列表的全部数据
-- @param recyclerView 侧滑栏列表控件
-- @param listIndex 点击的列表索引（点击的是第几个列表）
-- @param clickIndex 点击的项目索引（点击的第几个项目）
function onDrawerListItemClick(data, recyclerView, listIndex, itemIndex)
  --侧滑栏列表的数据是二维结构，所以需要先获取到点击项目所在列表的数据
  local listData = data.get(listIndex);
  --获取到所在列表的数据后获取点击项目的数据
  local itemData = listData.get(itemIndex);
  --最后获取到点击的项目的标题
  local itemTitle = itemData.getTitle();

  --TODO ：onDrawerListItemClick

end

-- @param keyword 搜索栏输入的文本
-- @description 顶栏搜索功能回调事件
function onSearchEvent(keyword)
  --TODO：onSearchEvent

end

-- @param title 点击的菜单标题
-- @description 顶栏菜单项目点击回调事件
function onMenuItemClick(title)
  --TODO：onMenuItemClick

end

--悬浮按钮点击事件
function onFloatingActionButtonClick(v)
  --TODO：onFloatingActionButtonClick
  activity.getUiManager().getCurrentFragment().getWebView().evaluateJavascript("goTop();",function end)
end
uiManager=activity.getUiManager()
--获取浏览器控件
webView=uiManager.getCurrentFragment().getWebView()

local intent=activity.getIntent()--获取成其他页面传来的连接。

function 加载链接(i)
  switch (i)
   case "1"
    --url=activity.getLuaDir().."/Color/index.html"
    local url="file:///android_asset/pages/BlankPage/zh-rCN/PrivacyPolicy.html"--隐私政策
    webView.loadUrl(url)
   case "2"
    --url=activity.getLuaDir().."/xy/index.html"
    local url="file:///android_asset/pages/BlankPage/zh-rCN/UserAgreement.html"--用户协议
    webView.loadUrl(url)
   case "3"
    --url=activity.getLuaDir().."/zc/index.html"
    local url="file:///android_asset/pages/BlankPage/zh-rCN/Disclaimer.html"--免责声明
    webView.loadUrl(url)
  end
end

require"import"
import "net.fusionapp.core.ui.fragment.WebInterface"
local uimanager=activity.uiManager
local fragment=uimanager.currentFragment
fragment.setWebInterface(WebInterface{
  onPageFinished=function(view,url)
    --页面加载结束事件
  end,
  onPageStarted=function(view,url,favicon)
    --页面开始加载事件
  end,
  onReceivedTitle=function(view,title)
    --获取到网页标题时加载的事件
    uiManager.getToolbar().titleText=title--设置标题为网页标题

  end,
  onLoadResource=function(view,url)
    --页面资源加载监听
    --可通过该方法获取网页上的资源
  end,
  onUrlLoad=function(view,url)
    --即将开始加载事件，url参数是即将加载的url
    --该函数返回一个布尔值
    --返回true则拦截本次加载
    return false
  end,
  onReceivedSslError=function(view, sslErrorHandler, sslError)
    --ssl证书错误处理事件
    --需自行处理，请返回true拦截原事件
    return false
  end
})




加载链接(intent.getStringExtra("i"))