require "import"
import "android.os.Bundle"
import "java.io.File"
import "net.fusionapp.core.ui.fragment.WebInterface"
import "android.app.*"
import "android.os.*"
import "android.widget.*"
import "android.view.*"
--FusionUtil=luajava.bindClass "net.fusionapp.core.util.FusionUtil"
android_R=luajava.bindClass "android.R"
--config=activity.getViewConfig().getToolbar().getMenus()
--------------------------
if activity.getPackageName()=="net.fusionapp" then
  R=luajava.bindClass "net.fusionapp.R"
 else
  R=luajava.bindClass "net.fusionapp.core.R"
end
if !activity.getSharedData("cookie") then
  cookie=nil
 else
  cookie=activity.getSharedData("cookie")
end
function Login()
  activity.startFusionActivity("login")
end
function copy(text)
  activity.getSystemService("clipboard").setText(text)
end
if this.getSharedData("自动更新")=="true" then
  uiManager=activity.getUiManager()
  import "android.graphics.Color"
  local colorAccent=Color.parseColor(uiManager.getColors().colorAccent)
  import "android.content.res.ColorStateList"
  local colorRipple=ColorStateList.valueOf(0x44444444)

  Http.get("",nil,'UTF-8',nil,function(code,content)
    import "cjson"
    if pcall(function(i) AllServerInfo=cjson.decode(i) end,content) then
      packinfo=activity.getPackageManager().getPackageInfo(activity.getPackageName(),0)
      app_version_name=tostring(packinfo.versionName)
      app_version_code=tointeger(packinfo.versionCode)
      last_version_name=tostring(AllServerInfo[1].last_version_name)
      last_version_code=tointeger(AllServerInfo[1].last_version_code)
      download_link=tostring(AllServerInfo[1].download_link)
      update_log=AllServerInfo[1].update_log
      if last_version_code and type(update_log)=="table" then
        if last_version_code>app_version_code then
          all_update_format=''
          for key,value in ipairs(update_log) do
            version_name=tostring(value.version_name)
            version_code=tointeger(value.version_code)
            content=tostring(value.content)
            if version_code>app_version_code then
              add_all_update_format='\n'..version_name..'('..tostring(version_code)..')\n'..string.gsub(content,'{br}','\n')
              all_update_format=all_update_format..'\n'..add_all_update_format
            end
          end
          last_version_format=app_version_name..'('..app_version_code..')-->'..last_version_name..'('..last_version_code..')'
          import "com.google.android.material.dialog.MaterialAlertDialogBuilder"
          dialog=MaterialAlertDialogBuilder(activity)
          .setTitle("发现应用更新")
          .setMessage(last_version_format..all_update_format)
          .setPositiveButton("下载",nil)
          .show()
          positive_bt=dialog.getButton(dialog.BUTTON_POSITIVE)
          positive_bt.setTextColor(colorAccent).setRippleColor(colorRipple).onClick=function()
            if positive_bt.getText()~='处理中' then
              positive_bt.setText('处理中')
              --此处放置下载更新文件代码
              task(1000,function()
                local Intent = luajava.bindClass "android.content.Intent"
                local Uri = luajava.bindClass "android.net.Uri"
                activity.startActivity(Intent("android.intent.action.VIEW",Uri.parse(download_link)))
                positive_bt.setText('完成')
              end)
            end
          end
          dialog.getButton(dialog.BUTTON_NEUTRAL).setTextColor(colorAccent).setRippleColor(colorRipple)
         elseif AllServerInfo[1].Announcement.Switch == 1 and activity.getSharedData("announcement") != AllServerInfo[1].Announcement.content then
          import"com.google.android.material.dialog.MaterialAlertDialogBuilder"
          local dialog=MaterialAlertDialogBuilder(activity)
          .setTitle("公告")
          .setMessage(AllServerInfo[1].Announcement.content)
          .setNeutralButton("不再提示",{onClick=function()
              activity.setSharedData("announcement",AllServerInfo[1].Announcement.content)
              print("将会再有改动时再次提醒")
            end})
          .setPositiveButton("确定",nil)
          --.setNegativeButton("取消",nil)
          .show()
          dialog.getButton(dialog.BUTTON_POSITIVE).setText(AllServerInfo[1].Announcement.button.text)
          if AllServerInfo[1].Announcement.button.Link ~= "无" then
            dialog.getButton(dialog.BUTTON_POSITIVE).onClick=function()
              local func = loadstring(AllServerInfo[1].Announcement.button.Link)
              func()
            end
          end
          if AllServerInfo[1].Announcement.Force == 1 then
            dialog.setCancelable(false)
            dialog.getButton(dialog.BUTTON_NEUTRAL).setText('退出')
            dialog.getButton(dialog.BUTTON_NEUTRAL).onClick=function()
              activity.finish()
            end
          end
          dialog.getButton(dialog.BUTTON_POSITIVE).setTextColor(colorAccent).setRippleColor(colorRipple)
          dialog.getButton(dialog.BUTTON_NEUTRAL).setTextColor(colorAccent).setRippleColor(colorRipple)
          dialog.getButton(dialog.BUTTON_NEGATIVE).setTextColor(colorAccent).setRippleColor(colorRipple)
        end
      end
    end
  end)
end

function Initialization()
  import "android.webkit.CookieManager"
  cookie=CookieManager.getInstance().getCookie("https://ysqbbs.com/")
  local cookie1,cookie2=cookie:match'YPSa_.+_comiis_homestyleid_u(.-)=.+%%2A(.-);'
  --print(cookie1,cookie2)
  if cookie1 or cookie2 then
    local uiManager=this.uiManager
    local wallpaper=uiManager.drawerWallpaper
    --获取抽屉栏壁纸ImageView
    import "com.bumptech.glide.Glide"
    local url="https://ysqbbs.com/source/plugin/comiis_app_homestyle/image/home_bg/"..cookie2
    Glide.with(activity).load(url).into(wallpaper)
    local avatarImageView=uiManager.drawerHeaderAvatarImageView
    --获取抽屉栏头像ImageView
    local url="https://ysqbbs.com/uc_server/avatar.php?uid="..cookie1.."&size=middle&ts="..math.random(000,999)
    --print(url)
    Glide.with(activity).load(url).into(avatarImageView)
    Http.get("https://ysqbbs.com/forum.php?mod=guide&view=hot&mobile=2",cookie,"utf-8",nil,function(code,content,cookie,header)
      if code==200 then
        local content=content:match('class="sidenv_edit">(.-)class="comiis_svg_box">')
        if content then
          local maintext,Lv,title,point=content:match('<p><span class=".-">(.-)</span><span class=".-">(.-)</span></p>.+<p class=".-"><span class=".-">(.-)</span><span class=".-">(.-)</span></p>')
          local textview=uiManager.drawerHeaderSecondaryTextView
          --获取抽屉栏页眉副文本TextView
          textview.text=title.." "..Lv.." "..point
          local textview=uiManager.drawerHeaderMainTextView
          --获取抽屉栏页眉主文本TextView
          textview.text=maintext
         else
          print("登陆失效，请重新登录")
          activity.setSharedData("cookie",nil)
        end
      end
    end)
    activity.setSharedData("cookie",cookie)
   else
    print("登陆失效，请重新登录")
    activity.setSharedData("cookie",nil)
    --Login()
    local sj=os.date("%H")
    local uiManager=this.uiManager
    local textview=uiManager.drawerHeaderMainTextView
    if(sj < "12") then
      textview.setText("早上好!请登录或注册")
     elseif(sj >="12" && sj < "14") then
      textview.setText("中午好!请登录或注册")
     elseif(sj >= "14" && sj < "18") then
      textview.setText("下午好!请登录或注册")
     elseif(sj >= "18") then
      textview.setText("晚上好!请登录或注册")
    end
  end
end

if not activity.getSharedData("Open_source_notification") then
  local SpannableStringBuilder = luajava.bindClass "android.text.SpannableStringBuilder"
  local Spannable = luajava.bindClass "android.text.Spannable"

  local spannableString = SpannableStringBuilder()
  local Pattern = luajava.bindClass "java.util.regex.Pattern"
  function Regular_Matching(reg,str)
    --正则表达式,需要匹配的内容
    local pattern = Pattern.compile(reg)
    local matcher = pattern.matcher(str)
    local tab = {}
    while matcher.find() do
      local start = matcher.start()
      local ends = matcher.end()
    tab[#tab+1] = {["start"]=start,["ends"]=ends}
  end
  return tab
end
local ForegroundColorSpan = luajava.bindClass "android.text.style.ForegroundColorSpan"
function Spannable_Text_Colour(spannable, str, colour, start, _end, flags) -- SpannableString,要更改颜色的内容（支持正则）,颜色[,开始位置,结束位置,flags]
  local tab = (str and Regular_Matching(str,spannable) or {{["start"]=tointeger(start),["ends"]=tointeger(_end)}}) or {} -- 判断是否有内容。否则将使用后面的位置。
  for _, v in pairs(tab) do
    spannable.setSpan(ForegroundColorSpan(colour), v.start, v.ends,
    flags or Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
  end
  return spannable
end
local URLSpan = luajava.bindClass "android.text.style.URLSpan"
function Spannable_Url(spannable, str, url, start, _end, flags) -- SpannableString,要更改的内容（支持正则）,url[,开始位置,结束位置,flags]
  local tab = (str and Regular_Matching(str,spannable) or {{["start"]=tointeger(start),["ends"]=tointeger(_end)}}) or {} -- 判断是否有内容。否则将使用后面的位置。
  for _, v in pairs(tab) do
    spannable.setSpan(URLSpan(url), v.start, v.ends,
    flags or Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
  end
  return spannable
end
local point_out_special = "本软件已开源，请使用前拆包检查有无加恶意代码，或者下载使用其他正常渠道。如有加密，请谨慎使用。"
local Open_source_address = "开源地址\nhttps://www.118pan.com/o25197"

spannableString.append(point_out_special)
---spannableString.append("\n")
spannableString.append(Open_source_address)
Spannable_Text_Colour(spannableString, point_out_special, 0xFFff0000)
Spannable_Url(spannableString, "https://www.118pan.com/o25197", "https://www.118pan.com/o25197")

local colorAccent=Color.parseColor(uiManager.getColors().colorAccent)
local colorRipple=ColorStateList.valueOf(0x44444444)
import"com.google.android.material.dialog.MaterialAlertDialogBuilder"
local dialog=MaterialAlertDialogBuilder(activity)
.setTitle("公告")
.setMessage(spannableString)
.setPositiveButton("确定",function()
  activity.setSharedData("Open_source_notification",true)
end)
.show()

dialog.getButton(dialog.BUTTON_POSITIVE).setTextColor(colorAccent).setRippleColor(colorRipple)
end

function delCookie()--删除全部cookie
  local CookieManager = luajava.bindClass "android.webkit.CookieManager"
  local cookieManager = CookieManager.getInstance()
  cookieManager.removeSessionCookie()
  cookieManager.removeAllCookie()
end

function recreate()
  activity.finish()
  activity.startFusionActivity(activity.getLoader().getPageName())
  activity.overridePendingTransition(android_R.anim.fade_in,android_R.anim.fade_out)
end


function onDrawerListItemClick(data, recyclerView, listIndex, itemIndex)
  local listData = data.get(listIndex)
  local itemData = listData.get(itemIndex)
  local itemTitle = itemData.getTitle()
  local uiManager=this.uiManager
  local viewPager=uiManager.viewPager
  switch itemTitle
   case "首页"
    viewPager.setCurrentItem(0)
    uiManager.drawerLayout.closeDrawer(3)
   case "社区"
    viewPager.setCurrentItem(1)
    uiManager.drawerLayout.closeDrawer(3)
   case "导读"
    viewPager.setCurrentItem(2)
    uiManager.drawerLayout.closeDrawer(3)
   case "我的"
    viewPager.setCurrentItem(3)
    uiManager.drawerLayout.closeDrawer(3)
   case "签到"
    this.uiManager.drawerLayout.closeDrawer(3)
    activity.startFusionActivity("SignIn")
   case "排行"
    local bundle=Bundle()
    bundle.putString("url","https://ysqbbs.com/misc.php?mod=ranklist&type=member&view=credit&mobile=2")
    --bundle.putInt("key",0)
    activity.startFusionActivity("Notopnolow",bundle)
   case "标签"
    local bundle=Bundle()
    bundle.putString("keyword","https://ysqbbs.com/misc.php?mod=tag&mobile=2")
    --bundle.putInt("key",0)
    activity.startFusionActivity("search",bundle)
   case "圈子"
    local bundle=Bundle()
    bundle.putString("url","https://ysqbbs.com/group.php?mod=index&mobile=2")
    --bundle.putInt("key",0)
    activity.startFusionActivity("Circle",bundle)
   case "访问推广"
    this.uiManager.viewPager.setCurrentItem(3)
    this.uiManager.drawerLayout.closeDrawer(3)
    activity.getUiManager().getCurrentFragment().getWebView().loadUrl("https://ysqbbs.com/home.php?mod=spacecp&ac=promotion")
   case "设置"
    activity.startFusionActivity("Setting")
   case "电脑版"
    activity.startFusionActivity("Computerversion")
   case "小黑屋"
    activity.startFusionActivity("Xiaoheiwu")
   case "当前在线"
    activity.startFusionActivity("Currently")
  end
end

local function popup(v)
  import "android.content.res.ColorStateList"
  import "androidx.appcompat.widget.PopupMenu"
  local Color = luajava.bindClass "android.graphics.Color"
  local colorAccent1=Color.parseColor(this.UiManager.colors.colorAccent)
  local textColorPrimary1=Color.parseColor(this.UiManager.colors.textColorPrimary)
  local textColorSecondary1=Color.parseColor(this.UiManager.colors.textColorSecondary)
  function table.unique(t,bArray,mainKey)
    local check = {}
    local n = {}
    local idx = 1
    for k, v in pairs(t) do
      local judgeKey = v
      if mainKey then
        judgeKey = v[mainKey] or v
      end
      if not check[judgeKey] then
        if bArray then
          n[idx] = v
          idx = idx + 1
         else
          n[k] = v
        end
        check[judgeKey] = true
      end
    end
    return n
  end
  local function pop(v,index,b)

    local popupMenu=PopupMenu(activity,v)
    local menu=popupMenu.menu
    --[[ if index~=0 then
      menu.add("左移").setIcon(R.drawable.material_ic_keyboard_arrow_left_black_24dp).setIconTintList(ColorStateList.valueOf(colorAccent1))
    end
    if index2 ~= index then
      menu.add("右移").setIcon(R.drawable.abc_ic_go_search_api_material).setIconTintList(ColorStateList.valueOf(colorAccent1))
    end]]
    menu.add("删除").setIcon(R.drawable.ic_delete_24dp).setIconTintList(ColorStateList.valueOf(colorAccent1))
    menu.setOptionalIconsVisible(true)

    popupMenu.onMenuItemClick=function(item)
      switch item.title
        --[[case "左移"
        local itemData = a.Data[index+1]
        a.remove(index)
        a.insert(index-1,itemData)
        a.notifyDataSetChanged()
       case "右移"
        local itemData = a.Data[index+1]
        a.remove(index)
        a.insert(index+1,itemData)
        a.notifyDataSetChanged()]]
       case "删除"
        recycler_view.getAdapter().remove(index)
        local cjson=require("cjson")
        local data=cjson.decode(this.getSharedData(b))
        table.remove(data,index+1)
        local json=cjson.encode(data)
        this.setSharedData(b,json)
      end
    end
    popupMenu.show()
  end
  local function History_Collection(a,b)
    import "androidx.recyclerview.widget.*"
    local view_table=
    {LinearLayout,
      layout_width="match",
      layout_height="match",
      orientation=1,
      {
        RecyclerView,
        id="recycler_view",
        layout_width="match",

        layout_height="wrap",
        paddingLeft='15dp';--布局内左距
        paddingRight='15dp';--布局内右距
        paddingTop='10dp';--布局内顶距
      },
    }
    import"com.google.android.material.dialog.MaterialAlertDialogBuilder"
    local dialog=MaterialAlertDialogBuilder(activity)
    .setTitle(a)
    .setView(loadlayout(view_table))
    .setNeutralButton("清空全部",{
      onClick=function()
        local data={}
        local cjson=require("cjson")
        local json=cjson.encode(data)
        this.setSharedData(b,json)
        print("清除成功")
      end
    })
    .setPositiveButton("确定",nil)
    .show()
    import "android.content.res.ColorStateList"
    colorRipple=ColorStateList.valueOf(0x44444444)
    dialog.getButton(dialog.BUTTON_POSITIVE).setTextColor(colorAccent1).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEUTRAL).setTextColor(colorAccent1).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEGATIVE).setTextColor(colorAccent1).setRippleColor(colorRipple)
    local MaterialCardView = luajava.bindClass "com.google.android.material.card.MaterialCardView"
    local list_item={
      LinearLayout,
      layout_width="match",
      layout_height="wrap",
      {
        MaterialCardView,
        id="card",
        layout_width="match",
        layout_height="wrap",
        cardElevation="0dp",--卡片阴影强度
        radius="0dp",--卡片圆角幅度
        {
          LinearLayout,
          layout_width="match",
          layout_height="wrap",
          padding="10dp",
          Orientation=1,
          {
            TextView,
            id="Title",
            textSize="14sp",
            textStyle="bold",
            textColor=textColorPrimary1,
          },
          {
            TextView,
            id="Text",
            ellipsize="end",
            singleLine=true;--设置单行输入
            textColor=textColorSecondary1,
            textSize="10sp",
            layout_marginTop="2dp",
          },
        },
      },
    }
    recycler_view.layoutManager=LinearLayoutManager(activity)
    local cjson=require("cjson")
    local data=cjson.decode(this.getSharedData(b))
    local data=table.unique(data,true,"Text")
    this.setSharedData(b,cjson.encode(data))
    local adapter=LuaRecyclerAdapter(activity,data,list_item)
    adapter.clickViewId="card"
    adapter.onItemClick=function(adapter,itemView,view,pos)
      --简单获取到当前item的Data表
      local itemData = adapter.Data[pos+1]
      local bundle=Bundle()
      bundle.putString("url",itemData.Text)
      --bundle.putInt("key",0)
      activity.startFusionActivity(itemData.PageName,bundle)

    end
    adapter.onItemLongClick=function(adapter,itemView,view,pos)
      pop(view,pos,b)
      return true
    end
    recycler_view.adapter=adapter
  end
  local popupMenu=PopupMenu(activity,v)
  local menu=popupMenu.menu
  menu.add("历史记录").setIcon(R.drawable.abc_ic_menu_overflow_material).setIconTintList(ColorStateList.valueOf(colorAccent1))
  menu.add("收藏列表").setIcon(R.drawable.abc_ic_menu_overflow_material).setIconTintList(ColorStateList.valueOf(colorAccent1))

  menu.setOptionalIconsVisible(true)

  popupMenu.onMenuItemClick=function(item)
    switch item.title
     case "历史记录"
      History_Collection("历史记录","History")
     case "收藏列表"
      History_Collection("收藏列表","Collection")
    end
  end
  popupMenu.show()
end

function onMenuItemClick(title)
  switch title

   case "登录"
    Login()
    --activity.startFusionActivity("login")
   case "登出"
    delCookie("https://ysqbbs.com/")
    activity.setSharedData("cookie",nil)
    print("退出登录成功")
    recreate()
    -- activity.startFusionActivity("Logoutoflogin")
   case "退出"
    activity.finish()
   case "历史记录"
    popup(this.uiManager.appBarLayout.getChildAt(0).getChildAt(2))
   case "复制链接"
    --先导入包
    local uiManager=activity.getUiManager()
    --获取当前页面的WebView
    local webView=uiManager.getCurrentFragment().getWebView()
    import "android.content.*"
    activity.getSystemService(Context.CLIPBOARD_SERVICE).setText(webView.getUrl())
   case "浏览器打开"
    local uiManager=activity.getUiManager()
    --获取当前页面的WebView
    local webView=uiManager.getCurrentFragment().getWebView()
    import "android.content.Intent"
    import "android.net.Uri"
    local viewIntent = Intent("android.intent.action.VIEW",Uri.parse(webView.getUrl()))
    activity.startActivity(viewIntent)
   case "刷新"
    activity.uiManager.currentFragment.webView.reload()
   case "分享网页"
    import "androidx.core.app.ShareCompat"
    ShareCompat.IntentBuilder
    .from(activity)
    .setText(activity.uiManager.currentFragment.getWebView().getTitle().."\n"..activity.uiManager.currentFragment.getWebView().getUrl())
    .setType("text/plain")
    .startChooser();
   case "网页查找"
    uiManager=activity.getUiManager()
    --获取浏览器控件
    webView=uiManager.getCurrentFragment().getWebView()
    import"com.google.android.material.dialog.MaterialAlertDialogBuilder"
    import "android.content.res.ColorStateList"
    local AlertDialog = luajava.bindClass "androidx.appcompat.app.AlertDialog"
    local TextInputLayout = luajava.bindClass "com.google.android.material.textfield.TextInputLayout"
    local TextInputEditText = luajava.bindClass "com.google.android.material.textfield.TextInputEditText"
    local view_table=
    {LinearLayout,
      layout_width="match",
      layout_height="match",
      orientation=1,
      {TextInputLayout,
        id="input_layout",
        layout_height="wrap",
        layout_marginLeft="20dp",
        layout_marginRight="20dp",
        layout_width="match",
        hint="内容",--设置输入框提示文本
        {TextInputEditText,
          id="edit_text",
          text=this.getSharedData("lookup"),
          layout_height="wrap",
          layout_width="match",
        },
      },

    }
    local function onSearchEvent(input)
      if input then
        webView.findAllAsync(input)
       else
        webView.findNext(true)
      end
      this.setSharedData("lookup",input)
      return true
    end

    local dialog=MaterialAlertDialogBuilder(activity)
    .setTitle("网页查找")
    .setView(loadlayout(view_table))
    .setPositiveButton("下一个",nil)
    .setNegativeButton("取消",{
      onClick=function()
        webView.clearMatches()
      end
    })
    .show()
    dialog.getButton(AlertDialog.BUTTON1).onClick=function()
      onSearchEvent(edit_text.text)
    end
    local lp =dialog.getWindow().getAttributes()
    lp.alpha = 0.6
    dialog.getWindow().setAttributes(lp)
    --local ColorDrawable = luajava.bindClass "android.graphics.drawable.ColorDrawable"
    --dialog.getWindow().setBackgroundDrawable(ColorDrawable());
    local lp = dialog.getWindow().getAttributes();
    lp.dimAmount=0.0
    dialog.getWindow().setAttributes(lp);
    dialog.getWindow().addFlags(WindowManager.LayoutParams.FLAG_DIM_BEHIND);
    import "android.graphics.Color"
    local colorAccent=Color.parseColor(activity.getUiManager().getColors().colorAccent)
    import "android.content.res.ColorStateList"
    local colorRipple=ColorStateList.valueOf(0x44444444)
    dialog.getButton(dialog.BUTTON_POSITIVE).setTextColor(colorAccent).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEUTRAL).setTextColor(colorAccent).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEGATIVE).setTextColor(colorAccent).setRippleColor(colorRipple)

  end
end
function print2(text,an,mButton1)
  import "com.google.android.material.snackbar.Snackbar"
  local anchor=activity.findViewById(android.R.id.content)
  Snackbar.make(anchor, text, Snackbar.LENGTH_LONG).setAction(an, View.OnClickListener{
    onClick=mButton1
  }).show();
end
function onFloatingActionButtonClick(v)
  --TODO：onFloatingActionButtonClick
  activity.getUiManager().getCurrentFragment().getWebView().evaluateJavascript("goTop();",function end)
end

function onSearchEvent(keyword)
  local bundle=Bundle().putString("keyword",keyword)
  activity.startFusionActivity("search",bundle)
end

fragment=activity.uiManager.getFragment(0).getWebView()
fragment2=activity.uiManager.getFragment(1).getWebView()
fragment3=activity.uiManager.getFragment(2).getWebView()
fragment4=activity.uiManager.getFragment(3).getWebView()
import "android.webkit.WebViewClient"
fragment.setWebViewClient(luajava.override(WebViewClient,{
  onReceivedError=function(_,view,webResourceRequest,webResourceError)
    --连接错误事件
  end,
  onPageFinished=function(_,view,url)
    --页面加载结束事件
    if this.getSharedData("显示FPS")=="true" then
      view.evaluateJavascript("Display_fps();",function end)
    end
  end,
  shouldOverrideUrlLoading=function(_,view,webResourceRequest)
    local url=tostring(webResourceRequest.getUrl())
    local packageName=url:match'ysqbbs%.com/member%.php%?mod=logging&action=login'
    local packageName2=url:match'ysqbbs%.com/forum%.php%?forumlist=1'
    local packageName3=url:match'ysqbbs%.com/forum%-.+%-.+%.html'
    local packageName4=url:match'ysqbbs%.com/thread%-.+%-.+%-.+%.html'
    local packageName6=url:match'ysqbbs%.com/home.php%?mod=space&uid=.+&do=profile'
    local packageName9=url:match'ysqbbs%.com/k_misign%-sign%.html'
    local packageName12=url:match'ysqbbs%.com/keke_integralmall%-keke_integralmall%.html'
    local packageName13=url:match'ysqbbs%.com/page%-2%.html'
    if packageName then
      Login()
      this.uiManager.viewPager.setCurrentItem(0)
      return true
     elseif packageName2 then
      this.uiManager.viewPager.setCurrentItem(1)
      return true
     elseif packageName3 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Plate",bundle)
      return true
     elseif packageName4 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Detailsofthepost",bundle)
      return true
     elseif packageName6 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Userspace",bundle)
      return true
     elseif packageName9 then
      activity.startFusionActivity("SignIn")
      return true
     elseif packageName12 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Background_Mall",bundle)
      return true
     elseif packageName13 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Notopnolow",bundle)
      return true
     else
      --页面即将加载
      return false
    end
  end,
  onPageStarted=function(_,view,url,bitmap)
    --页面开始加载
  end
}))
fragment2.setWebViewClient(luajava.override(WebViewClient,{
  onReceivedError=function(_,view,webResourceRequest,webResourceError)
    --连接错误事件
  end,
  onPageFinished=function(_,view,url)
    --页面加载结束事件
    if this.getSharedData("显示FPS")=="true" then
      view.evaluateJavascript("Display_fps();",function end)
    end

  end,
  shouldOverrideUrlLoading=function(_,view,webResourceRequest)
    local url=tostring(webResourceRequest.getUrl())
    local packageName=url:match'ysqbbs%.com/member%.php%?mod=logging&action=login'
    local packageName3=url:match'ysqbbs%.com/forum%-.+%-.+%.html'
    local packageName4=url:match'ysqbbs%.com/thread%-.+%-.+%-.+%.html'
    local packageName6=url:match'ysqbbs%.com/home.php%?mod=space&uid=.+&do=profile'
    local packageName9=url:match'ysqbbs%.com/plugin%.php%?id=k_misign:sign&mobile=2'
    if packageName then
      Login()
      this.uiManager.viewPager.setCurrentItem(0)
      return true
     elseif packageName3 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Plate",bundle)
      return true
     elseif packageName4 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Detailsofthepost",bundle)
      return true
     elseif packageName6 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Userspace",bundle)
      return true
     elseif packageName9 then
      activity.startFusionActivity("SignIn")
      return true
     else
      return false
    end
  end,
  onPageStarted=function(_,view,url,bitmap)
    --页面开始加载
  end
}))
fragment3.setWebViewClient(luajava.override(WebViewClient,{
  onReceivedError=function(_,view,webResourceRequest,webResourceError)
    --连接错误事件
  end,
  onPageFinished=function(_,view,url)
    --页面加载结束事件
    if this.getSharedData("显示FPS")=="true" then
      view.evaluateJavascript("Display_fps();",function end)
    end


  end,
  shouldOverrideUrlLoading=function(_,view,webResourceRequest)
    local url=tostring(webResourceRequest.getUrl())
    local packageName=url:match'ysqbbs%.com/member%.php%?mod=logging&action=login'
    local packageName3=url:match'ysqbbs%.com/forum%-.+%-.+%.html'
    local packageName4=url:match'ysqbbs%.com/thread%-.+%-.+%-.+%.html'
    local packageName6=url:match'ysqbbs%.com/home.php%?mod=space&uid=.+&do=profile'

    if packageName then
      Login()
      this.uiManager.viewPager.setCurrentItem(0)
      return true
     elseif packageName3 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Plate",bundle)
      return true
     elseif packageName4 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Detailsofthepost",bundle)
      return true
     elseif packageName6 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Userspace",bundle)
      return true
     else
      return false
    end
  end,
  onPageStarted=function(_,view,url,bitmap)
    --页面开始加载
  end
}))

fragment4.setWebViewClient(luajava.override(WebViewClient,{
  onPageFinished=function(_,view,url)
    --页面加载结束事件
    if this.getSharedData("显示FPS")=="true" then
      view.evaluateJavascript("Display_fps();",function end)
    end

  end,
  shouldOverrideUrlLoading=function(_,view,webResourceRequest)
    local url=tostring(webResourceRequest.getUrl())
    local packageName=url:match'ysqbbs%.com/member%.php%?mod=logging&action=login'
    local packageName3=url:match'ysqbbs%.com/forum%-.+%-.+%.html'
    local packageName4=url:match'ysqbbs%.com/thread%-.+%-.+%-.+%.html'
    local packageName6=url:match'ysqbbs%.com/home.php%?mod=space&uid=.+&do=profile'
    local packageName10=url:match'ysqbbs%.com/forum.php%?mod=viewthread&tid=.+'
    local packageName11=url:match'ysqbbs%.com/plugin.php%?id=comiis_app_homestyle&mobile=.+'
    local packageName15=url:match'ysqbbs%.com/home%.php%?mod=space&do=profile$'
    local packageName22=url:match'ysqbbs%.com/space%-uid%-.+%.html'
    local packageName25=url:match'ysqbbs%.com/home%.php%?mod=space&do=pm&subop=view&touid=.+'
    if packageName then
      Login()
      this.uiManager.viewPager.setCurrentItem(0)
      return true
     elseif packageName3 then
      local bundle=Bundle()
      bundle.putString("url",url)
      activity.startFusionActivity("Plate",bundle)
      return true
     elseif packageName4 or packageName10 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Detailsofthepost",bundle)
      return true
     elseif packageName6 or packageName15 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Userspace",bundle)
      return true
     elseif packageName11 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Background_Mall",bundle)
      return true
     elseif packageName22 then
      local uid=url:match('uid%-(.+)%.html')
      --print("https://avatar-bbs.mt2.cn/uc_server/avatar.php?uid="..uid.."&size=middle")
      local bundle=Bundle()
      bundle.putString("url","https://ysqbbs.com/home.php?mod=space&uid="..uid.."&do=profile")
      --bundle.putInt("key",0)
      activity.startFusionActivity("Userspace",bundle)
      return true
     elseif packageName25 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Userspace",bundle)
      return true
     else
      return false
    end
  end,

}))
if cookie then
  Initialization()
 else
  --Login()

  local sj=os.date("%H")
  local uiManager=this.uiManager
  local textview=uiManager.drawerHeaderMainTextView
  if(sj < "12") then
    textview.setText("早上好!请登录或注册")
   elseif(sj >="12" && sj < "14") then
    textview.setText("中午好!请登录或注册")
   elseif(sj >= "14" && sj < "18") then
    textview.setText("下午好!请登录或注册")
   elseif(sj >= "18") then
    textview.setText("晚上好!请登录或注册")
  end
end






local uiManager=this.uiManager
local textview2=uiManager.drawerHeaderSecondaryTextView
--获取抽屉栏页眉副文本TextView
textview2.onClick=function()--点击事件
  if cookie then
    this.uiManager.viewPager.setCurrentItem(3)
    this.uiManager.drawerLayout.closeDrawer(3)
   else
    Login()
  end
end;

local textview=uiManager.drawerHeaderMainTextView
--获取抽屉栏页眉主文本TextView
textview.onClick=function()--点击事件
  if cookie then
    if textview.text=="请点击刷新" then
      Initialization()
     else
      this.uiManager.viewPager.setCurrentItem(3)
      this.uiManager.drawerLayout.closeDrawer(3)
      activity.getUiManager().getCurrentFragment().getWebView().loadUrl("https://ysqbbs.com/plugin.php?id=nimba_rename&mobile=2")
    end
   else
    Login()
  end
end;

local wallpaper=uiManager.drawerWallpaper
--获取抽屉栏壁纸ImageView
wallpaper.onClick=function()--点击事件

  if cookie then
    local bundle=Bundle()
    bundle.putString("url","https://ysqbbs.com/plugin.php?id=comiis_app_homestyle&mobile=2")
    --bundle.putInt("key",0)
    activity.startFusionActivity("Background_Mall",bundle)
    --activity.startFusionActivity("Background_Mall")
    print("更改后需重新登陆")
   else
    Login()
  end
end;
local avatarImageView=uiManager.drawerHeaderAvatarImageView
--获取抽屉栏头像ImageView
avatarImageView.onClick=function()--点击事件
  if cookie then
    activity.startFusionActivity("Changetheavatar")
    print("更改后需重新登陆")
   else
    Login()
  end
end;

if this.getSharedData("自动签到") == "true" and tonumber(os.date("%d")) ~= tonumber(this.getSharedData("Check-in_time")) and activity.getSharedData("cookie") then
  Http.get("https://ysqbbs.com/plugin.php?id=k_misign:sign&operation=qiandao&format=text&formhash="..this.getSharedData("Automatic_check-in_data"),cookie,"utf-8",nil,function(code,content,cookie,header)
    if code==200 then
      local content=content:match('%[CDATA%[(.-)%]%]')
      --print(content)
      if content == "今日已签" then
        this.setSharedData("Check-in_time",os.date("%d"))
       elseif content == "已签到" then
        --print("自动签到成功")
        --[[ local uiManager=activity.getUiManager()
        import "android.graphics.Color"
        local colorAccent=Color.parseColor(uiManager.getColors().colorAccent)
        import "android.content.res.ColorStateList"
        local colorRipple=ColorStateList.valueOf(0x44444444)
        import"com.google.android.material.dialog.MaterialAlertDialogBuilder"
        local dialog=MaterialAlertDialogBuilder(activity)
        .setTitle("提示")
        .setMessage("自动签到成功")
        .setPositiveButton("确定",nil)
        --.setNegativeButton("取消",nil)
        .show()
        dialog.getButton(dialog.BUTTON_POSITIVE).setTextColor(colorAccent).setRippleColor(colorRipple)
        dialog.getButton(dialog.BUTTON_NEUTRAL).setTextColor(colorAccent).setRippleColor(colorRipple)
        dialog.getButton(dialog.BUTTON_NEGATIVE).setTextColor(colorAccent).setRippleColor(colorRipple)]]
        print2("自动签到成功","确定",function()end)
        this.setSharedData("Check-in_time",os.date("%d"))
       elseif content == "签到失败" then
        print2("自动签到失败，请重新手动点击签到或者重新登录","前往",function() activity.startFusionActivity("SignIn") end)
       else
        print2("自动签到失败，请重新手动点击签到或者重新登录","前往",function() activity.startFusionActivity("SignIn") end)
      end
    end
  end)
end
--[==[

function 提取Cookie(url)
  import "android.webkit.CookieManager"
  local cook=CookieManager.getInstance().getCookie(url)
  return cook
end

function GetLogin(user,pass)
  web=LuaWebView(activity)
  activity.setContentView(web)
  web.visibility=8;--隐藏webView
  Http.get("https://ysqbbs.com/member.php?mod=logging&action=login&mobile=2",function(code,content)
    local dl_url="https://ysqbbs.com/member.php?mod=logging&action=login&loginsubmit=yes&loginhash=%s&handlekey=loginform&inajax=1"
    local dl_data="formhash=%s&referer=https://ysqbbs.com/forum.php?mod=guide&view=hot&mobile=2&fastloginfield=username&cookietime=31104000&username=%s&password=%s&questionid=0&answer="
    local formhash=string.match(content,[[formhash" value='(.-)']])

    web.loadUrl(dl_url:format(content:match([[loginhash=(.-)"]])).."?"..dl_data:format(formhash,user,pass))

    print(提取Cookie("https://ysqbbs.com"))

  end)
end
--GetLogin("账号","密码")






Http.get("https://ysqbbs.com/forum.php?mod=guide&view=hot&mobile=2",cookie,"utf-8",header,function(code,content,cookie,header)
  if code==200 then
    --activity.getSystemService("clipboard").setText(content)
  end
end)

]==]

local packinfo=activity.getPackageManager().getPackageInfo(activity.getPackageName(),0)

local app_version_code=tointeger(packinfo.versionCode)

if app_version_code == 30 and !this.getSharedData("自动上下页") then
  this.setSharedData("自动上下页","false")
  import "com.google.android.material.dialog.MaterialAlertDialogBuilder"
  dialog=MaterialAlertDialogBuilder(activity)
  .setTitle("新功能")
  .setMessage("欢迎更新到新版本，在这里我们更新了一个重大的功能，可以自动的上一页下一页加载评论并拼接，去设置里开启功能看看吧")
  .setPositiveButton("前往",nil)
  .show()
  positive_bt=dialog.getButton(dialog.BUTTON_POSITIVE)
  positive_bt.onClick=function()
    activity.startFusionActivity("Setting")
  end
end