-- @author 寒歌
-- @description Main是应用的主模块，其中注册了应用运行中UI事件的回调、Activity生命周期的回调等
-- 你也可以在此编写启动事件代码，或控制应用运行逻辑、自定义应用UI等等。
-- @other 本模版已为你编写好基础事件，建议在阅读注释并理解相关参数意义后再进行扩展编写
-- 特别注意：本初始化模板为自定义视图演示模板，未提供其它功能使用示例，如需了解其它内置UI组件使用示例，请创建其它对应模板
--
require"import"
import "android.widget.*"
import "android.graphics.Color"
import "net.fusionapp.core.ui.adapter.BasePagerAdapter"
import "com.google.android.material.switchmaterial.SwitchMaterial"
--import "androidx.recyclerview.widget.*"
--import "androidx.core.widget.NestedScrollView"
--导入layout布局
import "layout"
import "android.graphics.Color"
FusionUtil=luajava.bindClass "net.fusionapp.core.util.FusionUtil"
android_R = luajava.bindClass "android.R"
if activity.packageName=="net.fusionapp" then
  R=luajava.bindClass"net.fusionapp.R"
 else
  R=luajava.bindClass"net.fusionapp.core.R"
end

config=activity.getViewConfig().getToolbar().getMenus()

local colors=this.uiManager.getColors()
colorPrimary=Color.parseColor(colors.colorPrimary)
colorAccent=Color.parseColor(colors.colorAccent)
colorTextPrimary=Color.parseColor(colors.textColorPrimary)
colorTextSecondary=Color.parseColor(colors.textColorSecondary)--副
colorBackground=Color.parseColor(colors.windowBackground)--主体背景

--UI管理器
UiManager=this.UiManager
local viewPager=UiManager.viewPager
--加载layout
local list=ArrayList()
list.add(loadlayout(layout))

viewPager.setAdapter(BasePagerAdapter(list))
function print2(t)
  import "com.google.android.material.snackbar.Snackbar"
  local parent=UiManager.coordinatorLayout
  local duration=Snackbar.LENGTH_SHORT
  Snackbar.make(parent,t, duration)
  .setActionTextColor(Color.parseColor(UiManager.getColors().getColorAccent()))
  .setAction("确定",{onClick=function()

    end})
  .show()
end
function Account_login()
  import"com.google.android.material.dialog.MaterialAlertDialogBuilder"
  import "android.content.res.ColorStateList"
  local AlertDialog = luajava.bindClass "androidx.appcompat.app.AlertDialog"
  local TextInputLayout = luajava.bindClass "com.google.android.material.textfield.TextInputLayout"
  local TextInputEditText = luajava.bindClass "com.google.android.material.textfield.TextInputEditText"
  local view_table=
  {LinearLayout,
    layout_width="match",
    layout_height="match",
    orientation=1,
    {TextInputLayout,
      id="input_layout",
      layout_height="wrap",
      layout_marginLeft="20dp",
      layout_marginRight="20dp",
      --suffixText="后缀文本",
      --error="错误提示",
      layout_width="match",
      hint="请输入邮箱或账号",--设置输入框提示文本
      {TextInputEditText,
        id="edit_text",
        text=activity.getSharedData("email"),
        singleLine=true;--设置单行输入，禁止换行
        layout_height="wrap",
        layout_width="match",
      },
    },
    {TextInputLayout,
      id="input_layout2",
      layout_height="wrap",
      layout_marginLeft="20dp",
      layout_marginRight="20dp",
      --suffixText="后缀文本",
      --error="错误提示",
      layout_width="match",
      hint="请输入密码",--设置输入框提示文本
      {TextInputEditText,
        id="edit_text2",
        text=activity.getSharedData("password"),
        singleLine=true;--设置单行输入，禁止换行
        layout_height="wrap",
        layout_width="match",
      },
    },
  }

  local dialog=MaterialAlertDialogBuilder(activity)
  .setTitle("配置图床账号")
  .setView(loadlayout(view_table))
  .setPositiveButton("确定",nil)
  .setNegativeButton("取消",nil)
  .setNeutralButton("前往注册",{onClick=function(v)
      local Intent = luajava.bindClass "android.content.Intent"
      local Uri = luajava.bindClass "android.net.Uri"
      activity.startActivity(Intent("android.intent.action.VIEW",Uri.parse("https://www.helloimg.com/signup")))
    end})
  .show()
  import "android.content.res.ColorStateList"
  colorRipple=ColorStateList.valueOf(0x44444444)
  dialog.getButton(dialog.BUTTON_POSITIVE).setTextColor(colorAccent).setRippleColor(colorRipple)
  dialog.getButton(dialog.BUTTON_NEUTRAL).setTextColor(colorAccent).setRippleColor(colorRipple)
  dialog.getButton(dialog.BUTTON_NEGATIVE).setTextColor(colorAccent).setRippleColor(colorRipple)

  task(100,function()
    local Context = luajava.bindClass "android.content.Context"
    import "android.view.inputmethod.InputMethodManager"
    edit_text.getContext().getSystemService(Context.INPUT_METHOD_SERVICE).toggleSoftInput(0,InputMethodManager.HIDE_NOT_ALWAYS)
    edit_text.requestFocus()
  end)
  dialog.getButton(AlertDialog.BUTTON1).onClick=function()
    local text=edit_text.text
    local text2=edit_text2.text
    if text=="" then
      input_layout.setError("不可为空")
     elseif text2=="" then
      input_layout2.setError("不可为空")
     else
      print2("保存成功")
      activity.setSharedData("email",text)
      activity.setSharedData("password",text2)
      dialog.hide()
    end
  end
  edit_text.addTextChangedListener{
    onTextChanged=function()
      --事件
      if edit_text.text=="" then
        input_layout.setError("不可为空")
       else
        input_layout.setError(null)
      end
    end
  }
  edit_text2.addTextChangedListener{
    onTextChanged=function()
      --事件
      if edit_text2.text=="" then
        input_layout2.setError("不可为空")
       else
        input_layout2.setError(null)
      end
    end
  }
end
function Edit_Menu()
  import"com.google.android.material.dialog.MaterialAlertDialogBuilder"
  import "androidx.recyclerview.widget.*"
  import "com.google.android.flexbox.*"
  local AlertDialog = luajava.bindClass "androidx.appcompat.app.AlertDialog"
  local view_table=
  {LinearLayout,
    layout_width="match",
    layout_height="match",
    orientation=1,
    {
      RecyclerView,
      id="recycler_view",
      layout_width="match",
      layout_height="wrap",
      padding="10dp"
    }
  }
  local cjson=require("cjson")
  local data=cjson.decode(this.getSharedData("Menulist"))
  local function popup(v,a,index,index2)
    import "android.content.res.ColorStateList"
    import "androidx.appcompat.widget.PopupMenu"
    local Color = luajava.bindClass "android.graphics.Color"
    local colorAccent1=Color.parseColor(this.UiManager.colors.colorAccent)
    local textColorPrimary1=Color.parseColor(this.UiManager.colors.textColorPrimary)

    local popupMenu=PopupMenu(activity,v)
    local menu=popupMenu.menu
    if index~=0 then
      menu.add("左移").setIcon(R.drawable.material_ic_keyboard_arrow_left_black_24dp).setIconTintList(ColorStateList.valueOf(colorAccent1))
    end
    if index2 ~= index then
      menu.add("右移").setIcon(R.drawable.abc_ic_go_search_api_material).setIconTintList(ColorStateList.valueOf(colorAccent1))
    end
    if a.Data[index+1].Content then
      menu.add("删除").setIcon(R.drawable.ic_delete_24dp).setIconTintList(ColorStateList.valueOf(colorAccent1))
    end
    menu.setOptionalIconsVisible(true)

    popupMenu.onMenuItemClick=function(item)
      switch item.title
       case "左移"
        local itemData = a.Data[index+1]
        a.remove(index)
        a.insert(index-1,itemData)
        a.notifyDataSetChanged()
       case "右移"
        local itemData = a.Data[index+1]
        a.remove(index)
        a.insert(index+1,itemData)
        a.notifyDataSetChanged()
       case "删除"
        a.remove(index)
      end
    end
    popupMenu.show()
  end
  import "com.google.android.material.chip.Chip"
  --设置列表布局
  local list_item={
    LinearLayout,
    layout_width="wrap",
    layout_height="wrap",
    {
      Chip;
      layout_width="wrap";
      layout_height="wrap";
      layout_marginLeft='3dp';--布局左距
      layout_marginRight='3dp';--布局右距
      id="text",
      TextSize="15";
      TextColor=colorTextPrimary;
    };
  }

  local dialog=MaterialAlertDialogBuilder(activity)
  .setTitle("编辑排序")
  .setView(loadlayout(view_table))
  .setPositiveButton("确定",{onClick=function(v)
      local cjson=require("cjson")
      local json=cjson.encode(recycler_view.getAdapter().Data)
      this.setSharedData("Menulist",json)
      print2("保存成功")
    end})
  .setNegativeButton("取消",nil)
  .setNeutralButton("添加快捷回复",nil)
  .setCancelable(false)
  .show()
  import "android.content.res.ColorStateList"
  colorRipple=ColorStateList.valueOf(0x44444444)
  dialog.getButton(dialog.BUTTON_POSITIVE).setTextColor(colorAccent).setRippleColor(colorRipple)
  dialog.getButton(dialog.BUTTON_NEUTRAL).setTextColor(colorAccent).setRippleColor(colorRipple)
  dialog.getButton(dialog.BUTTON_NEGATIVE).setTextColor(colorAccent).setRippleColor(colorRipple)

  local flexboxLayoutManager = ExetendFlexboxLayoutManager(this);
  --主轴为水平方向，起点在左端
  flexboxLayoutManager.setFlexDirection(FlexDirection.ROW);
  --按正常方向换行
  flexboxLayoutManager.setFlexWrap(FlexWrap.WRAP);
  --定义项目在副轴轴上如何对齐
  flexboxLayoutManager.setAlignItems(AlignItems.CENTER);
  --多个轴对齐方式
  flexboxLayoutManager.setJustifyContent(JustifyContent.FLEX_START);
  --设置最大显示行
  --flexboxLayoutManager.setMaxLine(2)
  recycler_view.setLayoutManager(flexboxLayoutManager);
  local adapt=LuaRecyclerAdapter(activity,data,list_item)
  adapt.clickViewId="text"
  adapt.onItemClick=function(
    adapter,--适配器对象
    itemView,--项目布局对象
    view,--点击的控件对象
    pos--点击的位置索引
    )
    popup(view,adapter,pos,adapter.getItemCount()-1)
  end
  recycler_view.adapter=adapt
  dialog.getButton(AlertDialog.BUTTON3).onClick=function()
    local TextInputLayout = luajava.bindClass "com.google.android.material.textfield.TextInputLayout"
    local TextInputEditText = luajava.bindClass "com.google.android.material.textfield.TextInputEditText"
    local view_table=
    {LinearLayout,
      layout_width="match",
      layout_height="match",
      orientation=1,
      {TextInputLayout,
        id="input_layout",
        layout_height="wrap",
        layout_marginLeft="20dp",
        layout_marginRight="20dp",
        --suffixText="后缀文本",
        --error="错误提示",
        counterEnabled="true",
        counterMaxLength="6",
        layout_width="match",
        hint="请输入标题",--设置输入框提示文本
        {TextInputEditText,
          id="edit_text",
          singleLine=true;--设置单行输入，禁止换行
          layout_height="wrap",
          layout_width="match",
        },
      },
      {TextInputLayout,
        id="input_layout2",
        layout_height="wrap",
        layout_marginLeft="20dp",
        layout_marginRight="20dp",
        --suffixText="后缀文本",
        --error="错误提示",
        layout_width="match",
        hint="请输入内容",--设置输入框提示文本
        {TextInputEditText,
          id="edit_text2",
          layout_height="wrap",
          layout_width="match",
        },
      },
    }

    local dialog=MaterialAlertDialogBuilder(activity)
    .setTitle("添加快捷回复")
    .setView(loadlayout(view_table))
    .setPositiveButton("确定",nil)
    .setNegativeButton("取消",nil)
    .setNeutralButton("？",{onClick=function(v)
        local dialog=MaterialAlertDialogBuilder(activity)
        .setTitle("提示")
        .setMessage("该功能可添加一个快捷回复按钮，点击后即可在框填入您的内容。\n该功能要求标题可超过六个字，长按后可删除。\n默认功能不可删除，但可调整排序。")
        .setPositiveButton("确定",nil)
        .show()
        dialog.getButton(dialog.BUTTON_POSITIVE).setTextColor(colorAccent).setRippleColor(colorRipple)

      end
    })
    .show()
    import "android.content.res.ColorStateList"
    colorRipple=ColorStateList.valueOf(0x44444444)
    dialog.getButton(dialog.BUTTON_POSITIVE).setTextColor(colorAccent).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEUTRAL).setTextColor(colorAccent).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEGATIVE).setTextColor(colorAccent).setRippleColor(colorRipple)

    task(100,function()
      local Context = luajava.bindClass "android.content.Context"
      import "android.view.inputmethod.InputMethodManager"
      edit_text.getContext().getSystemService(Context.INPUT_METHOD_SERVICE).toggleSoftInput(0,InputMethodManager.HIDE_NOT_ALWAYS)
      edit_text.requestFocus()
    end)
    dialog.getButton(AlertDialog.BUTTON1).onClick=function()
      local txt=edit_text.text
      local txt2=edit_text2.text
      if txt=="" then
        input_layout.setError("不可为空")
       elseif txt2=="" then
        input_layout2.setError("不可为空")
       else
        local data=adapt.Data
        table.insert(data,1,{text=txt,Content=txt2})
        adapt.notifyDataSetChanged()
        dialog.hide()
      end
    end
    edit_text.addTextChangedListener{
      onTextChanged=function()
        --事件
        if edit_text.text=="" then
          input_layout.setError("不可为空")
         elseif input_layout.getEditText().getText().length() > input_layout.getCounterMaxLength() then
          input_layout.setError("不得超过六位")
         else
          input_layout.setError(null)
        end
      end
    }
    edit_text2.addTextChangedListener{
      onTextChanged=function()
        --事件
        if edit_text2.text=="" then
          input_layout2.setError("不可为空")
         else
          input_layout2.setError(null)
        end
      end
    }
  end
end

local data={}
import "setting"
adp=LuaMultiAdapter(this,data,setting)
adp.add{__type=1,title="主题"}
adp.add{__type=2,subtitle="主题模式",message="设置软件的主题配色"}
--adp.add{__type=2,subtitle="界面风格",message="设置软件的界面风格"}
adp.add{__type=1,title="应用"}
adp.add{__type=2,subtitle="分享软件",message="将软件分享给好友"}
adp.add{__type=4,subtitle="自动更新",message="软件启动时检测新版",status={Checked=Boolean.valueOf(this.getSharedData("自动更新"))}}
adp.add{__type=1,title="快捷栏"}
--adp.add{__type=2,subtitle="图床选择",message="当前："..activity.getSharedData("password")}
--adp.add{__type=2,subtitle="图床账号",message="本地图片上传至云图床"}
adp.add{__type=2,subtitle="编辑菜单",message="编辑排列方式及添加"}
adp.add{__type=4,subtitle="自动签到",message="打开软件自动签到",status={Checked=Boolean.valueOf(this.getSharedData("自动签到"))}}
adp.add{__type=1,title="JS"}
adp.add{__type=4,subtitle="URL超连接",message="将帖子/空间(私聊)内容中的链接自动设置超链接",status={Checked=Boolean.valueOf(this.getSharedData("URL超连接"))}}
adp.add{__type=4,subtitle="自动上下页",message="帖子中自动加载上一页、下一页评论",status={Checked=Boolean.valueOf(this.getSharedData("自动上下页"))}}
adp.add{__type=4,subtitle="显示FPS",message="在网页左上角显示FPS帧率",status={Checked=Boolean.valueOf(this.getSharedData("显示FPS"))}}

adp.add{__type=1,title="其他"}
--adp.add{__type=5,subtitle="一言一句",status={Checked=Boolean.valueOf(this.getSharedData("一言一句"))}}
adp.add{__type=4,subtitle="下一页重调用",message="点击帖子下一页后，将再次调用页面进行打开",status={Checked=Boolean.valueOf(this.getSharedData("下一页重调用"))}}
adp.add{__type=2,subtitle="BUG反馈",message="将软件问题反馈给我"}
adp.add{__type=2,subtitle="清理缓存",message="清理软件缓存垃圾"}
adp.add{__type=3,subtitle="关于软件"}

listView.setAdapter(adp)

function recreate()
  activity.finishAffinity()
  activity.startFusionActivity("main")
  activity.overridePendingTransition(android_R.anim.fade_in,android_R.anim.fade_out)
end

function switchNightTheme(newThemeName)
  activity.getLoader().updatePageConfig()
  FusionUtil.changeTheme(activity.getLoader().getProjectDir().getAbsolutePath(), newThemeName)
  recreate()
end

--列表点击事件
listView.setOnItemClickListener(AdapterView.OnItemClickListener{
  onItemClick=function(id,v,zero,one)
    if v.Tag.status ~= nil then
      if v.Tag.status.Checked then
        this.setSharedData(v.Tag.subtitle.Text,"false")
        data[one].status["Checked"]=false
       else
        this.setSharedData(v.Tag.subtitle.Text,"true")
        data[one].status["Checked"]=true
      end
      --print(v.Tag.subtitle.Text)
      -- print(v.Tag.status.Checked)--带开关列表项事件
      switch(v.Tag.subtitle.Text)
       case "URL超连接"
        if !v.Tag.status.Checked then
          print"开启后，部分链接可能会异常"
        end
       case "自动上下页"
        if !v.Tag.status.Checked then
          print"开启后，可能会有BUG"
        end
       case "自动签到"
        if !this.getSharedData("Automatic_check-in_data") then
          this.setSharedData(v.Tag.subtitle.Text,"false")
          data[one].status["Checked"]=false
          activity.startFusionActivity("SignIn")
          print("当前账号签到数据为空，请先配置")
          print("点击签到后，将会自动获取")
        end

      end
     else
      switch(v.Tag.subtitle.Text)
       case "清理缓存"
        this.newActivity("Setting/Clean")
       case "主题模式"
        import"com.google.android.material.dialog.MaterialAlertDialogBuilder"
        local items={"深色主题","浅色主题","跟随系统"}
        local function Night_Default()
          if activity.getSharedData("Theme") then
            if activity.getSharedData("Theme")=="Night" then
              return 0 --选中项索引
             elseif activity.getSharedData("Theme")=="Default_Light" then
              return 1 --选中项索引
             elseif activity.getSharedData("Theme")=="false" then
              return 2 --选中项索引
            end
           else
            return 2 --选中项索引
          end
        end
        local selectIndex=Night_Default() --选中项索引
        local dialog=MaterialAlertDialogBuilder(activity)
        .setTitle("主题模式")
        .setSingleChoiceItems(items,selectIndex,{
          onClick=function(dialog,i)
            if items[i+1]=="深色主题" then
              activity.setSharedData("Theme","Night")
              switchNightTheme("Night.json")
             elseif items[i+1]=="浅色主题" then
              activity.setSharedData("Theme","Default_Light")
              switchNightTheme("Default_Light.json")
             elseif items[i+1]=="跟随系统" then
              activity.setSharedData("Theme","false")
              recreate()
            end
          end
        })
        .show()
       case "BUG反馈"
        import "android.net.Uri"
        import "android.content.Intent"
        url="mqqwpa://im/chat?chat_type=wpa&uin=2801901164"
        activity.startActivity(Intent(Intent.ACTION_VIEW, Uri.parse(url)))
       case "分享软件"
        import "androidx.core.app.ShareCompat"
        ShareCompat.IntentBuilder
        .from(activity)
        .setText("")
        .setType("text/plain")
        .startChooser();
       case "关于软件"
        this.newActivity("Setting/Regard")
       case "图床账号"
        Account_login()
       case "编辑菜单"
        Edit_Menu()
       default
        print(v.Tag.subtitle.Text)--其他列表点击事件
      end
    end
    adp.notifyDataSetChanged()--更新列表
  end
})
