require "import"
import "android.os.Bundle"
import "java.io.File"
import "android.app.*"
import "android.os.*"
import "android.widget.*"
import "android.view.*"
import "com.google.android.material.button.MaterialButton"
import "android.graphics.Color"
--FusionUtil=luajava.bindClass "net.fusionapp.core.util.FusionUtil"
android_R=luajava.bindClass "android.R"
--config=activity.getViewConfig().getToolbar().getMenus()
--------------------------
if activity.getPackageName()=="net.fusionapp" then
  R=luajava.bindClass "net.fusionapp.R"
 else
  R=luajava.bindClass "net.fusionapp.core.R"
end
local uiManager=this.uiManager
local colors=uiManager.getColors()
colorPrimary=colors.colorPrimary--主色
colorAccent=colors.colorAccent--强调
colorTextPrimary=colors.textColorPrimary--主文本色
textColorSecondary=colors.textColorSecondary
colorBackground=colors.windowBackground--窗体背景色

if !this.getSharedData("显示FPS") then
  this.setSharedData("显示FPS","true")
end
if !this.getSharedData("URL超连接") then
  this.setSharedData("URL超连接","true")
end
if !this.getSharedData("Menulist") then
  local data={{text="加粗"},{text="斜体"},{text="下划线"},{text="删除线"},{text="字号文字"},{text="颜色文字"},{text="彩色文字"},{text="URL 超连接"},{text="Email 超连接"},{text="网络图片"},{text="水平线"},{text="对齐文本"},{text="代码文本"},{text="引用文本"},{text="隐藏文本"},{text="网络视频"},{text="表格"},{text="列表"},{text="联系QQ"}}
  local cjson=require("cjson")
  local json=cjson.encode(data)
  this.setSharedData("Menulist",json)
end
if !this.getSharedData("History") then
  local data={}
  local cjson=require("cjson")
  local json=cjson.encode(data)
  this.setSharedData("History",json)
  this.setSharedData("Collection",json)
end
if !this.getSharedData("自动更新") then
  this.setSharedData("自动更新","true")
end
if !this.getSharedData("自动签到") then
  this.setSharedData("自动签到","false")
end
if !this.getSharedData("下一页重调用") then
  this.setSharedData("下一页重调用","false")
end


require "import"
import "com.androlua.LuaDrawable"
import "android.graphics.RectF"
import "android.widget.TextView"
import "android.widget.FrameLayout"
function drawRubik()

  import "android.graphics.RectF"

  return LuaDrawable(function(c,p,d)

    local b = d.bounds

    local width = b.right

    local height = b.bottom

    local scaleState = {
      0,width/24,width/12,
      width/24,width/12,width/8,
      width/12,width/8,width/6
    }

    local directState = {true,true,true,true,true,true,true,true,true}

    local addNum = width/6/30

    p.setColor(Color.parseColor(colorAccent))

    return function(c)

      local t = os.clock()

      for k,v in ipairs(scaleState) do

        if directState[k] then

          directState[k]=scaleState[k]<width/6

          scaleState[k]=scaleState[k]+addNum

         else

          directState[k]=scaleState[k]<=0

          scaleState[k]=scaleState[k]-addNum

        end

      end

      c.drawRect(RectF(scaleState[1],scaleState[1],width/3-scaleState[1],height/3-scaleState[1]),p);

      c.drawRect(RectF(width/3+scaleState[2],scaleState[2],width/3*2-scaleState[2],height/3-scaleState[2]),p);

      c.drawRect(RectF(width/3*2+scaleState[3],scaleState[3],width-scaleState[3],height/3-scaleState[3]),p);

      c.drawRect(RectF(scaleState[4],height/3+scaleState[4],width/3-scaleState[4],height/3*2-scaleState[4]),p);

      c.drawRect(RectF(width/3+scaleState[5],height/3+scaleState[5],width/3*2-scaleState[5],height/3*2-scaleState[5]),p);

      c.drawRect(RectF(width/3*2+scaleState[6],height/3+scaleState[6],width-scaleState[6],height/3*2-scaleState[6]),p);

      c.drawRect(RectF(scaleState[7],height/3*2+scaleState[7],width/3-scaleState[7],height-scaleState[7]),p);

      c.drawRect(RectF(width/3+scaleState[8],height/3*2+scaleState[8],width/3*2-scaleState[8],height-scaleState[8]),p);

      c.drawRect(RectF(width/3*2+scaleState[9],height/3*2+scaleState[9],width-scaleState[9],height-scaleState[9]),p);

      d.invalidateSelf();

    end

  end)

end



local aly={
  FrameLayout;
  layout_height="fill";
  layout_width="fill";
  background=colorBackground;
  {
    TextView;
    layout_height="20%w";
    gravity="center";
    layout_gravity="center";
    textSize="18sp";
    layout_width="20%w";
    backgroundDrawable=drawRubik();
  };
  {
    TextView;
    gravity="center";
    layout_gravity="center";
    layout_marginTop='70dp';--布局顶距
    textColor=colorAccent;--文字颜色
    textSize="25sp";
    text="加载中";
  };
};

activity.setContentView(loadlayout(aly))


local SpannableStringBuilder = luajava.bindClass "android.text.SpannableStringBuilder"
local Spannable = luajava.bindClass "android.text.Spannable"

local spannableString = SpannableStringBuilder("欢迎使用源社区Lite，根据相关政策规定，在使用前你需要先认真阅读并同意《用户协议》与《隐私政策》及《免责声明》后才能开始使用本软件。")
local Pattern = luajava.bindClass "java.util.regex.Pattern"
function Regular_Matching(reg,str)
  --正则表达式,需要匹配的内容
  local pattern = Pattern.compile(reg)
  local matcher = pattern.matcher(str)
  local tab = {}
  while matcher.find() do
    local start = matcher.start()
    local ends = matcher.end()
  tab[#tab+1] = {["start"]=start,["ends"]=ends}
end
return tab
end

-- 使用前先导入相关类
local ForegroundColorSpan = luajava.bindClass "android.text.style.ForegroundColorSpan"
function Spannable_Text_Colour(spannable, str, colour, start, _end, flags) -- SpannableString,要更改颜色的内容（支持正则）,颜色[,开始位置,结束位置,flags]
  local tab = (str and Regular_Matching(str,spannable) or {{["start"]=tointeger(start),["ends"]=tointeger(_end)}}) or {} -- 判断是否有内容。否则将使用后面的位置。
  for _, v in pairs(tab) do
    spannable.setSpan(ForegroundColorSpan(colour), v.start, v.ends,
    flags or Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
  end
  return spannable
end

-- 使用前先导入相关类
local ClickableSpan = luajava.bindClass "android.text.style.ClickableSpan"
function Spannable_Clickable(spannable, str, Click, start, _end, flags) -- SpannableString,要更改的内容（支持正则）,点击回调事件[,开始位置,结束位置,flags]
  local tab = (str and Regular_Matching(str,spannable) or {{["start"]=tointeger(start),["ends"]=tointeger(_end)}}) or {} -- 判断是否有内容。否则将使用后面的位置。
  for _, v in pairs(tab) do
    spannable.setSpan(ClickableSpan({
      onClick=function(view)
        Click(view)
      end,
      updateDrawState=function(ds)
        local Color = luajava.bindClass "android.graphics.Color"
        -- ds.setColor(Color.parseColor("#FF0090FF")) --设置颜色
        ds.setUnderlineText(false) --去掉下划线
      end
    }), v.start, v.ends,
    flags or Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
  end
  return spannable
end
local URLSpan = luajava.bindClass "android.text.style.URLSpan"
function Spannable_Url(spannable, str, url, start, _end, flags) -- SpannableString,要更改的内容（支持正则）,url[,开始位置,结束位置,flags]
  local tab = (str and Regular_Matching(str,spannable) or {{["start"]=tointeger(start),["ends"]=tointeger(_end)}}) or {} -- 判断是否有内容。否则将使用后面的位置。
  for _, v in pairs(tab) do
    spannable.setSpan(URLSpan(url), v.start, v.ends,
    flags or Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
  end
  return spannable
end
local function 跟随系统()
  --[[
 @author jies辰
 @description fusionapp跟随系统深色模式，深色模式主题为Night.json
]]
  import "net.fusionapp.core.util.FusionUtil"
  android_R = luajava.bindClass "android.R"
  import "android.app.UiModeManager"
  import "android.content.Context"
  local systemDarkMode=activity.getSystemService(Context.UI_MODE_SERVICE).getNightMode()==UiModeManager.MODE_NIGHT_YES
  local uiManager=this.uiManager
  if systemDarkMode~=uiManager.getThemeConfig().isNightMode()then
    if systemDarkMode then newThemeName="Night.json" else newThemeName="Default_Light.json" end
    activity.getLoader().updatePageConfig()
    FusionUtil.changeTheme(activity.getLoader().getProjectDir().getAbsolutePath(),newThemeName)
    FusionUtil.setNightMode(systemDarkMode)
    activity.finish()
    activity.newActivity(activity.getLoader().getPageName())
    activity.overridePendingTransition(android_R.anim.fade_in,android_R.anim.fade_out)
   elseif activity.getSharedData("Doyouagree")=="true" and SimplePermissions.checkPermission("android.permission.WRITE_EXTERNAL_STORAGE")==true then
    activity.startFusionActivity("Homepage")
    activity.finish()
   else
    Dialog()
  end
end

local point_out_special = ("本软件已开源，请使用前拆包检查有无加恶意代码，或者下载使用其他正常渠道。如有加密，请谨慎使用。")
local Open_source_address = "开源地址\nhttps://www.118pan.com/o25197"
spannableString.append("\n\n")
spannableString.append(point_out_special)
---spannableString.append("\n")
spannableString.append(Open_source_address)

function Dialog()
  import "com.google.android.material.bottomsheet.BottomSheetDialog"
  mBottomSheetDialog=BottomSheetDialog(activity);
  mBottomSheetDialog.setContentView(loadlayout("layout/main")).getWindow().setDimAmount(0.5);
  if Build.VERSION.SDK_INT >= 21 then
    mBottomSheetDialog.getWindow().addFlags(WindowManager.LayoutParams.FLAG_DRAWS_SYSTEM_BAR_BACKGROUNDS);
  end
  mBottomSheetDialog.getWindow().findViewById(R.id.design_bottom_sheet).setBackgroundResource(android.R.color.transparent);
  mBottomSheetDialog.show().setCancelable(false)
  install.onClick=function(v)--控件点击事件
    -- 如果你发现此代码报错，不要怀疑，你没有启用模块，此部分需要简易权限申请模块，请到fa2官方群获取或联系我
    local requiresPermissions=SimplePermissions.Permission.Group.STORAGE
    --1.2版本内置一些基础权限的字符串，详情可以拆包查看
    --{"android.permission.WRITE_EXTERNAL_STORAGE",  "android.permission.READ_EXTERNAL_STORAG"}
    if (#SimplePermissions.checkPermission(requiresPermissions)==0) then
      activity.setSharedData("Doyouagree","true")
      activity.startFusionActivity("Homepage")
      activity.finish()
     else
      SimplePermissions:with()--启动权限申请
      :permission(requiresPermissions)--请求权限
      :start()
      :callback(function(a,b,c)
        if a then
          activity.setSharedData("Doyouagree","true")
          activity.startFusionActivity("Homepage")
          activity.finish()
         else
          print("好家伙，你不同意权限。")
        end
      end)
    end
  end
  Spannable_Text_Colour(spannableString, "《用户协议》", Color.parseColor(colorAccent))
  Spannable_Clickable(spannableString, "《用户协议》",function(v)
    activity.startFusionActivity("BlankPage",Bundle().putString("i","2"))
  end)
  Spannable_Text_Colour(spannableString, "《隐私政策》", Color.parseColor(colorAccent))
  Spannable_Clickable(spannableString, "《隐私政策》",function(v)
    activity.startFusionActivity("BlankPage",Bundle().putString("i","1"))
  end)
  Spannable_Text_Colour(spannableString, "《免责声明》", Color.parseColor(colorAccent))
  Spannable_Clickable(spannableString, "《免责声明》",function(v)
    activity.startFusionActivity("BlankPage",Bundle().putString("i","3"))
  end)
  Spannable_Text_Colour(spannableString, point_out_special, 0xFFff0000)
  Spannable_Url(spannableString, "https://www.118pan.com/o25197", "https://www.118pan.com/o25197")
  -- 别忘了设这个，否则无法响应点击。
  local LinkMovementMethod = luajava.bindClass "android.text.method.LinkMovementMethod"
  point_out.setMovementMethod(LinkMovementMethod.getInstance())
  point_out.setText(spannableString)
end

if activity.getSharedData("Theme") then
  if activity.getSharedData("Theme")=="Night" or activity.getSharedData("Theme")=="Default_Light" then
    if tonumber(Build.VERSION.SDK) < 25 then
      import"com.google.android.material.dialog.MaterialAlertDialogBuilder"

      local dialog=MaterialAlertDialogBuilder(activity)
      .setTitle("提示")
      .setMessage("您的安卓版本低于7.1以下，本软件可能将不可用")
      -- .setNeutralButton("中立",nil)
      .setPositiveButton("确定",{
        onClick=function()
          activity.finish()
        end
      })
      .setNegativeButton("取消",{
        onClick=function()
          if activity.getSharedData("Doyouagree")=="true" and SimplePermissions.checkPermission("android.permission.WRITE_EXTERNAL_STORAGE")==true then
            activity.startFusionActivity("Homepage")
            activity.finish()
           else
            Dialog()
          end
        end
      }).show()
      import "android.graphics.Color"
      local colorAccent=Color.parseColor(activity.getUiManager().getColors().colorAccent)
      import "android.content.res.ColorStateList"
      local colorRipple=ColorStateList.valueOf(0x44444444)
      dialog.getButton(dialog.BUTTON_POSITIVE).setTextColor(colorAccent).setRippleColor(colorRipple)
      dialog.getButton(dialog.BUTTON_NEUTRAL).setTextColor(colorAccent).setRippleColor(colorRipple)
      dialog.getButton(dialog.BUTTON_NEGATIVE).setTextColor(colorAccent).setRippleColor(colorRipple)

     elseif activity.getSharedData("Doyouagree")=="true" and SimplePermissions.checkPermission("android.permission.WRITE_EXTERNAL_STORAGE")==true then
      activity.startFusionActivity("Homepage")
      activity.finish()
     else
      Dialog()
    end
   else
    跟随系统()
  end
 else
  跟随系统()
end



