require "import"
import "android.widget.*"
import "android.view.View"
import "android.os.Bundle"
import "net.fusionapp.core.ui.UiManager"

datapath="/data/data/"..activity.getPackageName().."/userdata/"
keyword=activity.getIntent().getStringExtra("keyword") or "小白"

local uiManager=activity.getUiManager()
--获取当前页面的WebView
local webView=uiManager.getCurrentFragment().getWebView()
if keyword=="https://ysqbbs.com/misc.php?mod=tag&mobile=2" then
  webView.loadUrl(keyword)
 else
  webView.loadUrl("https://ysqbbs.com/search.php?mod=forum&srchtxt="..keyword.."&searchsubmit=yes")
  local uiManager=this.uiManager
  local toolbar=uiManager.toolbar
  --设置toolbar标题
  toolbar.titleText="搜索："..keyword
end
function copy(text)
  activity.getSystemService("clipboard").setText(text)
end

function onFloatingActionButtonClick(v)
  activity.uiManager.currentFragment.webView.reload()
end
function Login()
  activity.startFusionActivity("login")
end
function onMenuItemClick(title)
  switch title
   case "退出"
    activity.finish()
   case "复制链接"
    --先导入包
    local uiManager=activity.getUiManager()
    --获取当前页面的WebView
    local webView=uiManager.getCurrentFragment().getWebView()
    import "android.content.*"
    activity.getSystemService(Context.CLIPBOARD_SERVICE).setText(webView.getUrl())
   case "浏览器打开"
    local uiManager=activity.getUiManager()
    --获取当前页面的WebView
    local webView=uiManager.getCurrentFragment().getWebView()
    import "android.content.Intent"
    import "android.net.Uri"
    local viewIntent = Intent("android.intent.action.VIEW",Uri.parse(webView.getUrl()))
    activity.startActivity(viewIntent)
   case "网页查找"
    uiManager=activity.getUiManager()
    --获取浏览器控件
    webView=uiManager.getCurrentFragment().getWebView()
    import"com.google.android.material.dialog.MaterialAlertDialogBuilder"
    import "android.content.res.ColorStateList"
    local AlertDialog = luajava.bindClass "androidx.appcompat.app.AlertDialog"
    local TextInputLayout = luajava.bindClass "com.google.android.material.textfield.TextInputLayout"
    local TextInputEditText = luajava.bindClass "com.google.android.material.textfield.TextInputEditText"
    local WindowManager = luajava.bindClass "android.view.WindowManager"
    local view_table=
    {LinearLayout,
      layout_width="match",
      layout_height="match",
      orientation=1,
      {TextInputLayout,
        id="input_layout",
        layout_height="wrap",
        layout_marginLeft="20dp",
        layout_marginRight="20dp",
        layout_width="match",
        hint="内容",--设置输入框提示文本
        {TextInputEditText,
          id="edit_text",
          text=this.getSharedData("lookup"),
          layout_height="wrap",
          layout_width="match",
        },
      },

    }
    local function onSearchEvent(input)
      if input then
        webView.findAllAsync(input)
       else
        webView.findNext(true)
      end
      this.setSharedData("lookup",input)
      return true
    end

    local dialog=MaterialAlertDialogBuilder(activity)
    .setTitle("网页查找")
    .setView(loadlayout(view_table))
    .setPositiveButton("下一个",nil)
    .setNegativeButton("取消",{
      onClick=function()
        webView.clearMatches()
      end
    })
    .show()
    dialog.getButton(AlertDialog.BUTTON1).onClick=function()
      onSearchEvent(edit_text.text)
    end
    local lp =dialog.getWindow().getAttributes()
    lp.alpha = 0.6
    dialog.getWindow().setAttributes(lp)
    --local ColorDrawable = luajava.bindClass "android.graphics.drawable.ColorDrawable"
    --dialog.getWindow().setBackgroundDrawable(ColorDrawable());
    local lp = dialog.getWindow().getAttributes();
    lp.dimAmount=0.0
    dialog.getWindow().setAttributes(lp);
    dialog.getWindow().addFlags(WindowManager.LayoutParams.FLAG_DIM_BEHIND);
    import "android.graphics.Color"
    local colorAccent=Color.parseColor(activity.getUiManager().getColors().colorAccent)
    import "android.content.res.ColorStateList"
    local colorRipple=ColorStateList.valueOf(0x44444444)
    dialog.getButton(dialog.BUTTON_POSITIVE).setTextColor(colorAccent).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEUTRAL).setTextColor(colorAccent).setRippleColor(colorRipple)
    dialog.getButton(dialog.BUTTON_NEGATIVE).setTextColor(colorAccent).setRippleColor(colorRipple)
   case "分享网页"
    import "androidx.core.app.ShareCompat"
    ShareCompat.IntentBuilder
    .from(activity)
    .setText(activity.uiManager.currentFragment.getWebView().getTitle().."\n"..activity.uiManager.currentFragment.getWebView().getUrl())
    .setType("text/plain")
    .startChooser();
  end
end


function onSearchEvent(keyword)
  local uiManager=this.uiManager
  local toolbar=uiManager.toolbar
  --设置toolbar标题
  toolbar.titleText="搜索："..keyword
  webView.loadUrl("https://ysqbbs.com/search.php?mod=forum&srchtxt="..keyword.."&searchsubmit=yes")
end

local uimanager=activity.uiManager
local fragment=uimanager.currentFragment.getWebView()
import "android.webkit.WebViewClient"
fragment.setWebViewClient(luajava.override(WebViewClient,{
  onPageFinished=function(_,view,url)
    --页面加载结束事件
    if this.getSharedData("显示FPS")=="true" then
      view.evaluateJavascript("Display_fps();",function end)
    end

  end,
  shouldOverrideUrlLoading=function(_,view,webResourceRequest)
    local url=tostring(webResourceRequest.getUrl())
    local packageName4=url:match'ysqbbs%.com/thread%-.+%-.+%-.+%.html'
    local packageName6=url:match'ysqbbs%.com/home.php%?mod=space&uid=.+&do=profile'
    local packageName=url:match'ysqbbs%.com/member%.php%?mod=logging&action=login'
    local packageName3=url:match'ysqbbs%.com/forum%-.+%-.+%.html'

    if packageName then
      Login()
      print"请登录以后再搜索"
      return true
     elseif packageName4 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Detailsofthepost",bundle)
      return true
     elseif packageName6 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Userspace",bundle)
      return true
     elseif packageName3 then
      local bundle=Bundle()
      bundle.putString("url",url)
      --bundle.putInt("key",0)
      activity.startFusionActivity("Plate",bundle)
      return true
     else
      return false
    end
  end,
}))
